# Copyright 2012, 2013 Marco Ceppi, Canonical Ltd.  This software is
# licensed under the GNU Affero General Public License version 3 (see
# the file LICENSE).


def breadcrumbs(request):
    crumbs = []
    parts = filter(None, request.path_info.split("/"))
    if not len(parts) > 1:
        return []
    parts.insert(0, '')
    for i in range(1, len(parts)):
        if parts[i].lower() == 'hooks':
            crumbs.append({
                "url": u"/".join(parts[:i]),
                "name": "Hooks"
            })
        else:
            crumbs.append({"url": u"/".join(parts[: i + 1]),
                           "name": unicode(parts[i].replace(
                               "-", " ").replace("~", "").capitalize())})
    crumbs.insert(0, {'url': u'/', 'name': u'Home'})
    return crumbs


def sections(request):
    sections = [
        {"url": u"/", "name": u"Home", 'active': False},
        {"url": u"/charms", "name": u"Charms", 'active': False},
        {"url": u"/interfaces", "name": u"Interfaces", 'active': False},
        {"url": u"/recently-changed", "name": u"Changes", 'active': False},
    ]
    section = "/%s" % request.path_info[1:].split("/", 1)[0]
    # fix up oddballs
    if section.startswith("/~"):
        section = u"/charms"
    elif section == u"/interface-charm-map":
        section = u"/interfaces"
    for s in sections:
        if s['url'] == section:
            s['active'] = True
    # HACK for link to active series
    sections[1]['url'] = u'/charms/precise'
    return sections


def default_globals_factory(system):
    context, request = system['context'], system['request']

    return {
        'project': u'Charm Browser',
        'onload': u'',
        'breadcrumbs': breadcrumbs(request),
        'sections': sections(request)
    }
