# Copyright 2012, 2013 Marco Ceppi, Canonical Ltd.  This software is
# licensed under the GNU Affero General Public License version 3 (see
# the file LICENSE).

import atexit
import os
import shutil
import tempfile

from charmworld.utils import get_ini


settings = get_ini()

if settings.get('is_testing', 'false').lower() == 'true':
    CHARM_DIR = tempfile.mkdtemp()
    atexit.register(shutil.rmtree, CHARM_DIR, ignore_errors=True)
else:
    CHARM_DIR = os.path.abspath(os.path.expanduser('~/var/charms'))

CHARM_QUEUE = 'charm-queue'
# A basket is a bunch of bundles (a deployer file makes a basket).
BASKET_QUEUE = 'basket-queue'

MONGO_URL = settings.get('mongo.url')
if MONGO_URL is None:
    MONGO_URL = ('mongodb://%s:%s' % (settings.get('mongo.host'),
                 settings.get('mongo.port')))
DB_NAME = settings.get('mongo.database')

CHARM_PROOF_PATH = '/usr/share/charm-tools/scripts'

STORE_URL = 'https://store.juju.ubuntu.com'

CHARM_IMPORT_FILTER = None
